(in-package :cl-user)
(defpackage www.web
  (:use :cl
        :caveman2
        :www.config
        :www.view
        :www.db
        :datafly
        :sxql
	:cl-bcrypt)
  (:export :*web*))
(in-package :www.web)

;; for @route annotation
(syntax:use-syntax :annot)

;;
;; Application

(defclass <web> (<app>) ())
(defvar *web* (make-instance '<web>))
(clear-routing-rules *web*)

;;
;; Routing rules

(defroute "/" ()
  (render #P"index.html"))


(defroute ("/signup" :method :POST) (&key _parsed)
  (destructuring-bind ((v1 . username) (v2 . password) (v3 . appearance)) _parsed
    (with-connection (db)
      (datafly:execute
       (insert-into :users
	 (:username :password :appearance_r :appearance_g :appearance_b :x_pos :y_pos :logged_in :created)
	 (list username
	     (bcrypt:encode (bcrypt:make-password password))
	     (hex2rgb appearance :r)
	     (hex2rgb appearance :g)
	     (hex2rgb appearance :b) 0 0 0
	     (encode-universal-time 0 0 0 1 1 1970 0))))))
  (render #P"done.html"))

(defun hex2rgb (hex v)
  (ecase v
    (:r
     (parse-integer (subseq hex 1 3) :radix 16))
    (:g
     (parse-integer (subseq hex 3 5) :radix 16))
    (:b
     (parse-integer (subseq hex 5 7) :radix 16))))

;;
;; Error pages

(defmethod on-exception ((app <web>) (code (eql 404)))
  (declare (ignore app))
  (merge-pathnames #P"_errors/404.html"
                   *template-directory*))
